/// <reference types="react" />
import { ComponentClass, MouseEventHandler, ReactNode } from 'react';
import { ObjectClean } from 'typelevel-ts';
import { PartialKeys } from '@devexperts/utils/dist/object/object';
export declare const LIST: symbol;
export declare type TFullListProps = {
    theme: {
        container?: string;
    };
    children: ReactNode;
    level?: number;
};
export declare type TListProps = ObjectClean<PartialKeys<TFullListProps, 'theme'>>;
export declare const List: ComponentClass<TListProps>;
export declare type TFullListItemProps = {
    theme: {
        item?: string;
    };
    children?: ReactNode;
    level?: number;
    onClick?: MouseEventHandler<HTMLElement>;
};
export declare type TListItemProps = ObjectClean<PartialKeys<TFullListItemProps, 'theme'>>;
export declare const ListItem: ComponentClass<TListItemProps>;
export declare type TFullListItemGroupProps = {
    isCollapsed?: boolean;
    children: ReactNode;
    header?: ReactNode;
    theme: {
        itemGroup?: string;
        itemGroup_isCollapsed?: string;
        itemGroup__header?: string;
    };
    onClick?: MouseEventHandler<HTMLElement>;
};
export declare type TListItemGroupProps = ObjectClean<PartialKeys<TFullListItemGroupProps, 'theme'>>;
export declare const ListItemGroup: ComponentClass<TListItemGroupProps>;
