"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var tslib_1 = require("tslib");
var React = require("react");
var ReactDOM = require("react-dom");
var classnames = require("classnames");
var pure_1 = require("../../utils/pure");
var withTheme_1 = require("../../utils/withTheme");
exports.INPUT = Symbol('Input');
var RawInput = /** @class */ (function (_super) {
    tslib_1.__extends(RawInput, _super);
    function RawInput() {
        var _this = _super !== null && _super.apply(this, arguments) || this;
        _this.state = {
            isFocused: false,
        };
        _this.onFocus = function (e) {
            if (!_this.props.isDisabled && !_this.state.isFocused && !_this.isFocusingOnInput && _this.input) {
                var input = ReactDOM.findDOMNode(_this.input);
                if (input) {
                    _this.isFocusingOnInput = true;
                    input.focus();
                    _this.isFocusingOnInput = false;
                }
                _this.setState({
                    isFocused: true,
                });
                _this.props.onFocus && _this.props.onFocus(e);
            }
        };
        _this.onBlur = function (e) {
            if (!_this.props.isDisabled && _this.state.isFocused && !_this.isFocusingOnInput) {
                _this.setState({
                    isFocused: false,
                });
                _this.props.onBlur && _this.props.onBlur(e);
            }
        };
        _this.onChange = function (e) {
            _this.props.onValueChange && _this.props.onValueChange(e.target.value);
            _this.props.onChange && _this.props.onChange(e);
        };
        return _this;
    }
    RawInput.prototype.render = function () {
        var _this = this;
        var _a = this.props, theme = _a.theme, isDisabled = _a.isDisabled, isReadOnly = _a.isReadOnly, tabIndex = _a.tabIndex, children = _a.children, value = _a.value, error = _a.error, onClick = _a.onClick, onMouseDown = _a.onMouseDown, onMouseUp = _a.onMouseUp, onKeyDown = _a.onKeyDown, onKeyUp = _a.onKeyUp, onKeyPress = _a.onKeyPress, min = _a.min, placeholder = _a.placeholder, max = _a.max, type = _a.type, name = _a.name, pattern = _a.pattern, id = _a.id, onWheel = _a.onWheel;
        var isFocused = this.state.isFocused;
        var className = classnames(theme.container, (_b = {},
            _b[theme.container_isFocused] = !isDisabled && isFocused,
            _b[theme.container_isDisabled] = isDisabled,
            _b[theme.container_isReadOnly] = isReadOnly,
            _b[theme.container_hasError] = Boolean(error),
            _b));
        var isCustom = type === 'hidden';
        var keyboardEvents = {
            onKeyDown: onKeyDown,
            onKeyUp: onKeyUp,
            onKeyPress: onKeyPress,
        };
        return (React.createElement("div", tslib_1.__assign({ className: className, id: id, onClick: onClick, onMouseDown: onMouseDown, onMouseUp: onMouseUp, onFocus: this.onFocus, onBlur: this.onBlur, onWheel: onWheel, tabIndex: !isCustom && (isFocused || isDisabled) ? -1 : tabIndex }, isCustom && keyboardEvents),
            React.createElement("input", tslib_1.__assign({ className: theme.input, ref: function (el) { return (_this.input = el); }, value: value, type: type, min: min, max: max, pattern: pattern, name: name, onChange: this.onChange, placeholder: placeholder, tabIndex: -1, readOnly: isReadOnly, disabled: isDisabled }, !isCustom && keyboardEvents)),
            children));
        var _b;
    };
    RawInput.defaultProps = {
        tabIndex: 0,
    };
    RawInput = tslib_1.__decorate([
        pure_1.PURE
    ], RawInput);
    return RawInput;
}(React.Component));
exports.Input = withTheme_1.withTheme(exports.INPUT)(RawInput);
//# sourceMappingURL=Input.js.map